unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Ed_Name: TEdit;
    Ed_Strana: TEdit;
    Ed_KolVo: TEdit;
    Ed_Cena: TEdit;
    Ed_Trebuet: TEdit;
    Ed_FIO: TEdit;
    Ed_Data: TEdit;
    L_Name: TLabel;
    L_Strana: TLabel;
    L_KolVo: TLabel;
    L_Cena: TLabel;
    L_Pokupatel: TLabel;
    L_Trebuet: TLabel;
    L_FIO: TLabel;
    L_Data: TLabel;
    Add: TButton;
    RG: TRadioGroup;
    Delete: TButton;
    Ed_Pokupatel: TEdit;
    LeftClick: TBitBtn;
    RightClick: TBitBtn;
    AllLeftClick: TBitBtn;
    AllRightClick: TBitBtn;
    OD: TOpenDialog;
    SD: TSaveDialog;
    Open: TButton;
    Save: TButton;
    Otbor1: TButton;
    Ed_Otbor2: TEdit;
    Otbor2: TButton;
    Ed_Otbor3: TEdit;
    Otbor3: TButton;
    Close: TBitBtn;
    ClearAll: TButton;
    procedure RGClick(Sender: TObject);
    procedure AddClick(Sender: TObject);
    procedure RightClickClick(Sender: TObject);
    procedure LeftClickClick(Sender: TObject);
    procedure AllRightClickClick(Sender: TObject);
    procedure AllLeftClickClick(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure Otbor1Click(Sender: TObject);
    procedure Otbor2Click(Sender: TObject);
    procedure Otbor3Click(Sender: TObject);
    procedure ClearAllClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  p_sklad=^all_sklad;

  all_sklad = record
    name, strana : string[30];
    cena:integer;
    next, prior:p_sklad;
    case item : Char of
      'y': ( kolvo,trebuet:integer;
             pokupatel:string[30]
            );
      'n': ( fio,data:string[50] );
  end;

var
  Form1: TForm1;
  head   : p_sklad = nil;
  sklad  : p_sklad = nil;
  vsklad : p_sklad = nil;

implementation

{$R *.dfm}

procedure ClearAllSklad;
var
 item : p_sklad;
begin
  if (head = nil) then
    Exit;

  item := head;

  while (item^.next <> nil) do
  begin
    if (item^.prior <> nil) then
      Dispose(item^.prior);

    if (item^.next <> nil) then
      item := item^.next;
  end;

  Dispose(item);
  head := nil;
  sklad := nil;
  vsklad := nil;
end;

procedure DeleteItem(var item : p_sklad);
begin
  if (item = nil) then
    Exit;

  if (item = head) then
  begin
    if (item^.next <> nil) then
    begin
      head := item^.next;
      head.prior := nil;
    end
    else
    begin
      ClearAllSklad;
      item := nil;
      Exit;
    end;
  end
  else
  begin
    if (item^.prior <> nil) then
     item^.prior^.next := item^.next;

    if (item^.next <> nil) then
     item^.next^.prior := item^.prior;
  end;

  Dispose(item);
  item := nil;
end;


procedure viewsklad(skladview: p_sklad);
begin
  if (head = nil) then
  begin
    ShowMessage(' !');
    Exit;
  end;

  if (skladview <> nil) then
  begin
    with skladview^ do
    begin
      Form1.Ed_Name.text   := name;
      Form1.Ed_Strana.text := strana;
      Form1.Ed_Cena.text   := inttostr(cena);
      case item of
        'y':
          begin
            Form1.Ed_KolVo.text     := inttostr(kolvo);
            Form1.Ed_Pokupatel.text := pokupatel;
            Form1.Ed_Trebuet.text   := inttostr(trebuet);
            Form1.RG.ItemIndex      := 0;
          end;
        'n':
          begin
            Form1.Ed_FIO.text  := fio;
            Form1.Ed_Data.text := data;
            Form1.RG.ItemIndex := 1;
          end;
      end;
    end;
    sklad := skladview;
  end;
end;

procedure TForm1.RGClick(Sender: TObject);
begin
  case RG.itemindex  of
    0:  begin
          L_KolVo.Visible     := True;
          L_Pokupatel.Visible := True;
          L_trebuet.Visible   := True;
          L_FIO.Visible       := False;
          L_Data.Visible      := False;
          Ed_KolVo.Visible    := True;
          Ed_Pokupatel.Visible:= True;
          Ed_trebuet.Visible  := True;
          Ed_Fio.Visible      := False;
          Ed_Data.Visible     := False;
        end;
    1:  begin
          l_KolVo.Visible    := False;
          l_FIO.Visible      := True;
          l_Data.Visible     := True;
          l_Pokupatel.Visible:= False;
          l_Trebuet.Visible  := False;
          ed_KolVo.Visible   := False;
          ed_Fio.Visible     := True;
          ed_Data.Visible    := True;
          ed_pokupatel.Visible :=False;
          ed_trebuet.Visible   :=False;
        end;
  end;
end;

procedure TForm1.AddClick(Sender: TObject);
var
  sklad_pred: p_sklad;
  i:integer;
begin
  if ((RG.ItemIndex=0) and
      (Ed_Name.Text<>'') and
      (Ed_Strana.Text<>'') and
      (Ed_Cena.Text<>'') and
      (Ed_KolVo.Text<>'') and
      (Ed_Pokupatel.Text<>'') and
      (Ed_Trebuet.Text<>''))
    or
     ((RG.ItemIndex=1) and
      (Ed_Name.Text<>'') and
      (Ed_Strana.Text<>'') and
      (Ed_Cena.Text<>'') and
      (Ed_FIO.Text<>'') and
      (Ed_Data.Text<>''))
  then
  begin
    sklad_pred := sklad;
    //    
    new(sklad);
    //   ,   New    
    //    "" 
    ZeroMemory(sklad,SizeOf(all_sklad));

    with sklad^ do
    begin
//      prior := nil;  //  ,    ZeroMemory    nil
//      next := nil;   //  ,    ZeroMemory    nil
      name := ed_Name.text;
      strana := ed_Strana.text;
      cena := StrToIntDef(ed_Cena.text,0);
      case rG.itemindex of
        0: begin
             item  := 'y';
             kolvo := StrToIntDef(ed_KolVo.text,0);
             pokupatel := ed_Pokupatel.text;
             trebuet   := StrToIntDef(ed_Trebuet.text,0);
           end;
        1: begin
             item := 'n';
             fio  := ed_FIO.text;
             data := ed_Data.text;
           end;
      end;
    end;

    if (head <> nil) then
    begin
      sklad^.prior := sklad_pred;
      sklad_pred^.next := sklad;
    end
    else
      head := sklad;

    for i := 0 to Self.ComponentCount-1 do
      if (Self.Components[i] is TEdit) then
        TEdit(Self.Components[i]).Clear;
  end
  else
    showmessage('   !');
end;

procedure TForm1.SaveClick(Sender: TObject);
var
  File0: File of all_sklad;
  ib: p_sklad;
begin
  if (head = nil) then   //  
    Exit;
  {         }
  SD.Filter := '  (*.skld)|*.skld';
  SD.DefaultExt := '.skld';

  SD.InitialDir := ExtractFileDir(Application.ExeName);

  if SD.Execute then
  begin
    AssignFile(File0, SD.Filename);
    Rewrite(File0);
    ib := head;
    while (ib<>nil) do
    begin
      write(File0,ib^);
      ib:=ib^.next;
    end;
    closefile(File0);
  end;
end;

procedure TForm1.LeftClickClick(Sender: TObject);
begin
  if (head = nil) or (sklad = nil) then
    showmessage (' ')
  else
  begin
    if (sklad = head) then
      showmessage('  ')
    else
      sklad := sklad^.prior;

    viewsklad(sklad);
  end;
end;

procedure TForm1.RightClickClick(Sender: TObject);
begin
  if (head = nil) or (sklad = nil) then
    showmessage (' ')
  else
  begin
    if (sklad^.next = nil) then
      showmessage('  ')
    else
      sklad:=sklad^.next;

    viewsklad(sklad);
  end;
end;

procedure TForm1.AllLeftClickClick(Sender: TObject);
begin
  if (head = nil) then
    showmessage (' ')
  else
  begin
    sklad := head;
    showmessage ('  !');
    viewsklad(sklad);
  end;
end;

procedure TForm1.AllRightClickClick(Sender: TObject);
begin
  if (head = nil) then
    showmessage (' ')
  else
  begin
    sklad := head;

    while (sklad^.next <> nil) do
      sklad := sklad^.next;

    showmessage('  ');
    viewsklad(sklad);
  end;
end;

procedure TForm1.OpenClick(Sender: TObject);
var
  File0: file of all_sklad;
  sklad_pred: p_sklad;
begin
  {         }
  OD.Filter := '  (*.skld)|*.skld';
  OD.DefaultExt := '.skld';


  OD.InitialDir := ExtractFileDir(Application.ExeName);
  if OD.Execute then
  begin
    ClearAllSklad;

    AssignFile(File0, OD.Filename);
    Reset(File0);
    while not eof(File0) do
    begin
      sklad_pred := sklad;
      new(sklad);

      read(File0, sklad^);
      sklad^.next  := nil;
      sklad^.prior := sklad_pred;

      if (head = nil) then
        head := sklad
      else
        sklad_pred^.next := sklad;
    end;
    closefile(File0);

    vsklad := head;
    viewsklad(vsklad);
  end;
end;

procedure TForm1.DeleteClick(Sender: TObject);
var
  delitem : p_sklad;
 // sklad_pred : p_sklad;
  i:integer;
begin
//  if (head=nil) then
//    showmessage (' ')
//  else if (sklad^.next = nil) and (sklad^.prior = nil) then
//    showmessage ('  ')
//  else if (sklad^.prior = nil) then
//  begin
//    sklad^.next^.prior := nil;
//    head := sklad^.next;
//    dispose(sklad);
//    sklad := head
//  end
//  else if (sklad^.next = nil) then
//  begin
//    sklad^.prior^.next := nil;
//    sklad_pred := sklad^.prior;
//    dispose(sklad);
//    sklad := sklad_pred;
//  end
//  else
//  begin
//    sklad^.prior^.next:=sklad^.next;
//    sklad_pred:=sklad;
//    sklad:=sklad^.next;
//    dispose(sklad^.prior);
//    sklad^.prior:=sklad_pred^.prior;
//  end;


  for i := 0 to Self.ComponentCount-1 do
    if (Self.Components[i] is TEdit) then
      TEdit(Self.Components[i]).Clear;

  if (head = nil) then
  begin
    showmessage (' ');
  end
  else if (sklad <> nil) then
  begin
    delitem := sklad;
    if (sklad^.next <> nil) then
    begin
       sklad := sklad^.next;
       DeleteItem(delitem);
    end
    else if (sklad^.prior <> nil) then
    begin
      sklad := sklad^.prior;
      DeleteItem(delitem);
    end
    else
      ClearAllSklad;

    if (sklad <> nil) then
      viewsklad(sklad);
  end;
end;

procedure TForm1.ClearAllClick(Sender: TObject);
//var
//  item: p_sklad;
begin
  ClearAllSklad;

//  if Sklad = nil then
//    Exit
//  else
//    item := sklad;
//  while item^.next <> nil do
//  begin
//    if item^.prior <> nil then
//      Dispose(item^.prior);
//    if item^.next <> nil then
//      item := item^.next;
//  end;
//  Dispose(item);
//  Sklad := nil;

  RG.ItemIndex := 0;
  Ed_Name.Text := '';
  Ed_Strana.Text := '';
  Ed_Cena.Text := '';
  Ed_KolVo.Text := '';
  Ed_Pokupatel.Text := '';
  Ed_Trebuet.Text := '';
  Ed_FIO.Text := '';
  Ed_Data.Text := '';
end;

procedure TForm1.Otbor1Click(Sender: TObject);
var
  File0: file of all_sklad;
  sklad_pred: p_sklad;
  //*******************************************************//
  // (1)   . !!   !!! //
  //*******************************************************//
  buf: all_sklad;
begin
  {         }
  OD.Filter := '  (*.skld)|*.skld';
  OD.DefaultExt := '.skld';


  OD.InitialDir := ExtractFileDir(Application.ExeName);
  if OD.Execute then
  begin

    ClearAllSklad;

    AssignFile(File0, OD.Filename);
    Reset(File0);
    while not eof(File0) do
    begin
      //******************************************************************//
      // (2)     . !!     !!! //
      //******************************************************************//
      read(File0, buf);


      {        RG.     

      if ( (RG.ItemIndex = 0) and ( buf.item = 'y') )
        or
         ( (RG.ItemIndex = 1) and ( buf.item = 'n') )
      then
      }
      if ( buf.item = 'y') then
      begin
        sklad_pred := sklad;
      //******************************************************************//
      // (3)    ,    //
      //******************************************************************//
        new(sklad);
        CopyMemory(sklad,@buf,SizeOf(all_sklad));

        sklad^.next := nil;
        sklad^.prior := sklad_pred;

        if (head = nil) then
          head := sklad
        else
          sklad_pred^.next := sklad;
      end;
    end;
    closefile(File0);

    vsklad := head;
    viewsklad(vsklad);
  end;
end;

procedure TForm1.Otbor2Click(Sender: TObject);
var
  File0: file of all_sklad;
  sklad_pred: p_sklad;
  //*******************************************************//
  // (1)   . !!   !!! //
  //*******************************************************//
  buf: all_sklad;
begin
  {         }
  OD.Filter := '  (*.skld)|*.skld';
  OD.DefaultExt := '.skld';


  OD.InitialDir := ExtractFileDir(Application.ExeName);
  if OD.Execute then
  begin

    ClearAllSklad;

    AssignFile(File0, OD.Filename);
    Reset(File0);
    while not eof(File0) do
    begin
      //******************************************************************//
      // (2)     . !!     !!! //
      //******************************************************************//
      read(File0, buf);

      //     ...
      if (ed_Otbor2.Text = buf.pokupatel) or (ed_otbor2.Text = buf.fio) then
      begin
        sklad_pred := sklad;

      //******************************************************************//
      // (3)    ,    //
      //******************************************************************//
        new(sklad);
        CopyMemory(sklad,@buf,SizeOf(all_sklad));

        sklad^.next := nil;
        sklad^.prior := sklad_pred;

        if (head = nil) then
          head:=sklad
        else
          sklad_pred^.next := sklad;
      end;
    end;
    closefile(File0);

    vsklad := head;
    viewsklad(vsklad);
  end;
end;

procedure TForm1.Otbor3Click(Sender: TObject);
var
  File0: file of all_sklad;
  sklad_pred: p_sklad;
  //*******************************************************//
  // (1)   . !!   !!! //
  //*******************************************************//
  buf: all_sklad;
begin
  {         }
  OD.Filter := '  (*.skld)|*.skld';
  OD.DefaultExt := '.skld';


  OD.InitialDir := ExtractFileDir(Application.ExeName);
  if OD.Execute then
  begin

    ClearAllSklad;

    AssignFile(File0, OD.Filename);
    Reset(File0);
    while not eof(File0) do
    begin

      //******************************************************************//
      // (2)     . !!     !!! //
      //******************************************************************//
      read(File0, buf);

      //     ...
      if (ed_Otbor3.Text = buf.name) then
      begin
        sklad_pred := sklad;

      //******************************************************************//
      // (3)    ,    //
      //******************************************************************//
        new(sklad);
        CopyMemory(sklad,@buf,SizeOf(all_sklad));

        sklad^.next := nil;
        sklad^.prior := sklad_pred;
        if (head = nil) then
          head := sklad
        else
          sklad_pred^.next := sklad;
      end;
    end;
    closefile(File0);

    vsklad := head;
    viewsklad(vsklad);
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ClearAllSklad;
end;

end.

